/**
 * -------------------------------------------------------- *
 * ------------------- ПРИМЕРЫ ОБЪЕКТЫ -------------------- *
 * -------------------------------------------------------- *
 */

/**
 * -------------------------------------------------------- *
 * ------------------ КОНСТРУКТОР ОБЪЕКТА ----------------- *
 *                         функция                          *
 */
// функция - конструктор объекта person
function Person(name, age, per_height) {
    this.name = name;
    this.age = age;
    this.per_height = per_height;
}

/**
 * -------------------------------------------------------- *
 * ------------------ КОНСТРУКТОР ОБЪЕКТА ----------------- *
 *                    создание экземпляров                   *
 */
// создадим несколько объектов типа Person
let p1 = new Person('Jhon', 33, 182);
let p2 = new Person('Jack', 23, 170);
// выведем что получилось
console.log(p1);
// Person { name: 'Jhon', age: 33, per_height: 182 }
console.log(p2);
// Person { name: 'Jack', age: 23, per_height: 170 }

/**
* -------------------------------------------------------- *
* ------------------- ДОБАВЛЕНИЕ МЕТОДА ------------------ *
*                 с помощью "внешней функции"              *
*/
function say_hi() {
    console.log(this.name + ", Hi!");
}
// используем нашу функцию в качестве
// методов каждого из объектов
p1.say = say_hi;
p2.say = say_hi;
// вызовем методы каждого из объектов
p1.say(); // Jhon, Hi!
p2.say(); // Jack, Hi!

/**
* -------------------------------------------------------- *
* ------------------- ДОБАВЛЕНИЕ МЕТОДА ------------------ *
*                   с помощью конструктора                 *
*/
// функция - конструктор объекта person
function Person__(name, age, per_height) {
    this.name = name;
    this.age = age;
    this.per_height = per_height;
    this.moreOld = (n) => {
        this.age += n;
    }
}
let p3 = new Person__('Jhon', 33, 182);
console.log(p3.age); // 33
p3.moreOld(3); // повзрослел на три года
console.log(p3.age); // 36